import backend.anzeige.Einstellungen;
import backend.darstellungen.Zeichner;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Ellipse2D.Double;
import java.io.PrintStream;

public class KruemelDarstellungImpl
  extends DarstellungImpl
{
  public Ellipse2D kruemel;
  public int radius;
  
  public KruemelDarstellungImpl(int x, int y)
  {
    super(x, y);
    
    KruemelInititalisieren(x, y);
    RadiusSetzen(Einstellungen.ZellenRadiusGeben() / 2);
  }
  
  private void KruemelInititalisieren(int x, int y)
  {
    this.kruemel = new Ellipse2D.Double(this.xTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, 
      this.yTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, this.radius * 2, this.radius * 2);
    this.darstellung = this.kruemel;
    this.anzeigeManager.KruemelDarstellungHinzufuegen(this);
  }
  
  public void RadiusSetzen(int radiusNeu)
  {
    if ((radiusNeu >= 0) && (radiusNeu <= Einstellungen.ZellenRadiusGeben() / 2))
    {
      this.radius = radiusNeu;
      this.kruemel.setFrame(this.xTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, 
        this.yTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, this.radius * 2, this.radius * 2);
      Aktualisieren();
    }
    else
    {
      System.err.println("Der Radius des Kruemels muss größer als Null und kleiner-gleich dem halbenZellenradius:" + 
        Einstellungen.ZellenRadiusGeben() + " sein!");
    }
  }
  
  protected void Aktualisieren()
  {
    this.darstellung = this.kruemel;
    
    super.Aktualisieren();
  }
  
  public void PositionAktualisieren()
  {
    super.PositionAktualisieren();
    
    ((Ellipse2D.Double)this.darstellung).setFrame(this.xTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, 
      this.yTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius, this.radius * 2, this.radius * 2);
    Aktualisieren();
  }
  
  public void KruemelSymbolEntfernen()
  {
    this.anzeigeManager.KruemelDarstellungEntfernen(this);
  }
  
  public char TypGeben()
  {
    return 'K';
  }
}
