import backend.anzeige.Einstellungen;
import backend.darstellungen.Zeichner;
import java.awt.Graphics;
import java.awt.geom.Arc2D;
import java.awt.geom.Arc2D.Double;
import java.io.PrintStream;

public class MampfiDarstellungImpl
  extends DarstellungBeweglichImpl
{
  public double radius;
  public double startWinkel = 0.0D;
  public double bogenWinkel = 360.0D;
  public int bogenArt = 2;
  public Arc2D arc = new Arc2D.Double();
  
  public MampfiDarstellungImpl()
  {
    super(0, 0);
    this.darstellung = this.arc;
    this.anzeigeManager.MampfiDarstellungHinzufuegen(this);
    RadiusSetzen(Einstellungen.ZellenRadiusGeben() - 2);
  }
  
  public MampfiDarstellungImpl(int xNeu, int yNeu)
  {
    super(xNeu, yNeu);
    this.darstellung = this.arc;
    this.anzeigeManager.MampfiDarstellungHinzufuegen(this);
    RadiusSetzen(Einstellungen.ZellenRadiusGeben() - 2);
  }
  
  public void RadiusSetzen(int rad)
  {
    if ((rad >= 0) && (rad <= Einstellungen.ZellenRadiusGeben() - 1))
    {
      this.radius = rad;
      
      Aktualisieren();
    }
    else
    {
      System.err.println("Der Radius von Mampfi muss gr��er als Null und kleiner als der Zellenradius: " + 
        Einstellungen.ZellenRadiusGeben() + " sein!");
    }
  }
  
  public void StartWinkelSetzen(int winkel)
  {
    this.startWinkel = winkel;
    Aktualisieren();
  }
  
  public double StartWinkelGeben()
  {
    return this.startWinkel;
  }
  
  public int BogenArtGeben()
  {
    return this.bogenArt;
  }
  
  public double BogenWinkelGeben()
  {
    return this.bogenWinkel;
  }
  
  public double RadiusGeben()
  {
    return this.radius;
  }
  
  public void BogenWinkelSetzen(int winkel)
  {
    this.bogenWinkel = winkel;
    Aktualisieren();
  }
  
  public void BogenArtSetzen(int bogenArtNeu)
  {
    if ((bogenArtNeu == 0) || (bogenArtNeu == 1) || (bogenArtNeu == 2))
    {
      this.bogenArt = bogenArtNeu;
      

      Aktualisieren();
    }
    else
    {
      System.out.println("F�r Bogenart nur 0, 1 oder 2 eingeben!");
    }
  }
  
  public void Zeichnen(Graphics g)
  {
    double insetX = this.xTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius;
    double insetY = this.yTransformiert + Einstellungen.ZellenRadiusGeben() - this.radius;
    if (this.bewegtSich) {
      this.arc.setArc(insetX, insetY, this.radius * 2.0D, this.radius * 2.0D, this.startWinkel, 360.0D, 0);
    } else {
      this.arc.setArc(insetX, insetY, this.radius * 2.0D, this.radius * 2.0D, this.startWinkel, this.bogenWinkel, this.bogenArt);
    }
    this.darstellung = this.arc;
    super.Zeichnen(g);
  }
  
  public char TypGeben()
  {
    return 'm';
  }
}
