import backend.anzeige.Einstellungen;
import backend.darstellungen.Zeichner;
import java.awt.Graphics;
import java.awt.geom.Arc2D;
import java.awt.geom.Arc2D.Double;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
//import java.awt.geom.Ellipse2D.Double;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
//import java.awt.geom.Rectangle2D.Double;
import java.io.PrintStream;

public class MonsterDarstellungImpl
  extends DarstellungBeweglichImpl
{
  public float breite;
  public float hoehe;
  public float insetX;
  public float insetY;
  public Area figur = new Area();
  public char blickRichtung = 'W';
  
  public MonsterDarstellungImpl(int x, int y)
  {
    super(x, y);
    GroesseSetzen(Einstellungen.ZellenRadiusGeben() * 2 - 2);
    FigurErstellen();
    this.anzeigeManager.MonsterDarstellungHinzufuegen(this);
  }
  
  public void Zeichnen(Graphics g)
  {
    FigurErstellen();
    this.darstellung = this.figur;
    super.Zeichnen(g);
  }
  
  private void FigurErstellen()
  {
    this.figur.reset();
    






    Arc2D kopf = new Arc2D.Double(this.xTransformiert + this.insetX, this.yTransformiert + this.insetY, this.breite, this.hoehe / 2.0F, 0.0D, 180.0D, 0);
    Ellipse2D augeLinks = new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite / 4.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F, this.breite / 6.0F, this.hoehe / 6.0F);
    Ellipse2D augeRechts = new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite * 7.0F / 12.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F, this.breite / 6.0F, this.hoehe / 6.0F);
    Ellipse2D pupilleLinks = PupilleLinksErstellen();
    Ellipse2D pupilleRechts = PupilleRechtsErstellen();
    

    Rectangle2D rumpf = new Rectangle2D.Double(this.xTransformiert + this.insetX, this.yTransformiert + this.insetY + this.hoehe / 4.0F, this.breite, this.hoehe / 2.0F);
    float x3Rechts;
    float x3Links;
    //float x3Rechts;
    if (this.bewegtSich)
    {
      //float x3Links = this.xTransformiert + this.insetX + this.breite / 3.0F;
      x3Links = this.xTransformiert + this.insetX + this.breite / 3.0F;
      x3Rechts = this.xTransformiert + this.insetX + this.breite * 2.0F / 3.0F;
    }
    else
    {
      x3Links = this.xTransformiert + this.insetX;
      x3Rechts = this.xTransformiert + this.insetX + this.breite;
    }
    GeneralPath linkerFuss = new GeneralPath();
    linkerFuss.moveTo(this.xTransformiert + this.insetX, this.yTransformiert + this.insetY + this.hoehe / 4.0F + this.hoehe / 2.0F);
    linkerFuss.lineTo(this.xTransformiert + this.insetX + this.breite / 3.0F, this.yTransformiert + this.insetY + this.hoehe / 4.0F + this.hoehe / 2.0F);
    linkerFuss.lineTo(x3Links, this.yTransformiert + this.insetY + this.hoehe);
    linkerFuss.closePath();
    
    GeneralPath rechterFuss = new GeneralPath();
    rechterFuss.moveTo(this.xTransformiert + this.insetX + this.breite * 2.0F / 3.0F, this.yTransformiert + this.insetY + this.hoehe / 4.0F + this.hoehe / 2.0F);
    rechterFuss.lineTo(this.xTransformiert + this.insetX + this.breite, this.yTransformiert + this.insetY + this.hoehe / 4.0F + this.hoehe / 2.0F);
    rechterFuss.lineTo(x3Rechts, this.yTransformiert + this.insetY + this.hoehe);
    rechterFuss.closePath();
    
    Area augeRechtsArea = new Area(augeRechts);
    Area augeLinksArea = new Area(augeLinks);
    Area pupilleLinksArea = new Area(pupilleLinks);
    Area pupilleRechtsArea = new Area(pupilleRechts);
    Area rumpfArea = new Area(rumpf);
    Area kopfArea = new Area(kopf);
    Area linkerFussArea = new Area(linkerFuss);
    Area rechterFussArea = new Area(rechterFuss);
    

    this.figur.add(kopfArea);
    this.figur.add(rumpfArea);
    this.figur.subtract(augeLinksArea);
    this.figur.subtract(augeRechtsArea);
    this.figur.add(pupilleLinksArea);
    this.figur.add(pupilleRechtsArea);
    this.figur.add(linkerFussArea);
    this.figur.add(rechterFussArea);
  }
  
  private Ellipse2D PupilleLinksErstellen()
  {
    switch (this.blickRichtung)
    {
    case 'W': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite / 4.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'N': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite / 4.0F + this.breite / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'O': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite / 4.0F + this.breite * 2.0F / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'S': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite / 4.0F + this.breite / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe * 2.0F / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    }
    return null;
  }
  
  private Ellipse2D PupilleRechtsErstellen()
  {
    switch (this.blickRichtung)
    {
    case 'W': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite * 7.0F / 12.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'N': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite * 7.0F / 12.0F + this.breite / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'O': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite * 7.0F / 12.0F + this.breite * 2.0F / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    case 'S': 
      return new Ellipse2D.Double(this.xTransformiert + this.insetX + this.breite * 7.0F / 12.0F + this.breite / 24.0F, this.yTransformiert + this.insetY + this.hoehe / 6.0F + this.hoehe * 2.0F / 24.0F, this.breite * 2.0F / 24.0F, this.hoehe * 2.0F / 24.0F);
    }
    return null;
  }
  
  public void BlickRichtungSetzen(char blickrichtungNeu)
  {
    this.blickRichtung = blickrichtungNeu;
    Aktualisieren();
  }
  
  public char BlickRichtungGeben()
  {
    return this.blickRichtung;
  }
  
  public void GroesseSetzen(int seitenlaenge)
  {
    if ((seitenlaenge >= 0) && (seitenlaenge < 2 * Einstellungen.ZellenRadiusGeben()))
    {
      this.hoehe = seitenlaenge;
      this.breite = seitenlaenge;
      this.insetX = ((2 * Einstellungen.ZellenRadiusGeben() - this.breite) / 2.0F);
      this.insetY = ((2 * Einstellungen.ZellenRadiusGeben() - this.hoehe) / 2.0F);
      Aktualisieren();
    }
    else
    {
      System.err.println("Die Seitenlaenge der Monster muss größer als Null und kleiner als der Zelldurchmesser:" + 
        Einstellungen.ZellenRadiusGeben() * 2 + " sein!");
    }
  }
  
  public void GroesseSetzen(int breiteNeu, int hoeheNeu)
  {
    if ((hoeheNeu >= 0) && (breiteNeu >= 0) && (hoeheNeu < 2 * Einstellungen.ZellenRadiusGeben()) && (breiteNeu < 2 * Einstellungen.ZellenRadiusGeben()))
    {
      this.hoehe = hoeheNeu;
      this.breite = breiteNeu;
      this.insetX = ((2 * Einstellungen.ZellenRadiusGeben() - this.breite) / 2.0F);
      this.insetY = ((2 * Einstellungen.ZellenRadiusGeben() - this.hoehe) / 2.0F);
      Aktualisieren();
    }
    else
    {
      System.err.println("Die Höhe/Breite der Monster muss größer als Null und kleiner als derZellendurchmesser:" + 
        Einstellungen.ZellenRadiusGeben() * 2 + " sein!");
    }
  }
  
  public char TypGeben()
  {
    return 'M';
  }
}
