import backend.Ticker;
import backend.anzeige.AnzeigeFactory;
import backend.anzeige.Einstellungen;
import backend.anzeige.Farbe;
import backend.anzeige.InfoAnzeige;

public class SteuerungsAnzeige
{
  protected int punkteStand;
  protected int leben;
  protected int level;
  protected InfoAnzeige spielAnzeige;
  protected SteuerungsDummy steuerungsDummy;
  
  public SteuerungsAnzeige()
  {
    this.spielAnzeige = AnzeigeFactory.InfoAnzeigeErzeugen();
  }
  
  public SteuerungsAnzeige(int zellenAnzahl)
  {
    Einstellungen.ZellenRadiusBerechnen(zellenAnzahl);
    this.spielAnzeige = AnzeigeFactory.InfoAnzeigeErzeugen();
  }
  
  public void PunkteStandSetzen(int punkteStandNeu)
  {
    this.punkteStand = punkteStandNeu;
    this.spielAnzeige.PunkteSetzen(punkteStandNeu);
  }
  
  public void LebenSetzen(int anzahlNeu)
  {
    this.leben = anzahlNeu;
    this.spielAnzeige.LebenSetzen(anzahlNeu);
  }
  
  public void LevelSetzen(int nummerNeu)
  {
    this.level = nummerNeu;
    this.spielAnzeige.LevelSetzen(nummerNeu);
  }
  
  public void SchriftFarbeSetzen(String farbe)
  {
    this.spielAnzeige.SchriftFarbeSetzen(Farbe.FarbeErzeugen(farbe));
  }
  
  public void HintergrundFarbeSetzen(String farbe)
  {
    this.spielAnzeige.HintergrundFarbeSetzen(Farbe.FarbeErzeugen(farbe));
  }
  
  public void Anmelden(Object o)
  {
    this.steuerungsDummy = new SteuerungsDummy(o);
    if (this.steuerungsDummy.istAufpasser()) {
      AnzeigeFactory.AufpasserSetzen(this.steuerungsDummy);
    }
  }
  
  public void TickerStarten(int zeitIntervall)
  {
    if (this.steuerungsDummy != null) {
      if (this.steuerungsDummy.istTickEmpfaenger()) {
        Ticker.TickerErzeugen(this.steuerungsDummy, zeitIntervall);
      }
    }
  }
  
  public void LabyrinthAnzeigeLoeschen() {}
  
  public void TickerAnhalten()
  {
    Ticker.AnhaltenSetzen(true);
  }
}
