import backend.anzeige.Einstellungen;
import backend.darstellungen.Zeichner;
import backend.darstellungen.ZellDarstellung;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.Rectangle2D.Double;
import java.awt.geom.Rectangle2D; //neu

public class ZellDarstellungImpl
  extends DarstellungImpl
  implements ZellDarstellung
{
  public int breite = Einstellungen.ZellenRadiusGeben() * 2;
  public int hoehe = Einstellungen.ZellenRadiusGeben() * 2;
  public int zentrumX = this.xTransformiert + Einstellungen.ZellenRadiusGeben();
  public int zentrumY = this.xTransformiert + Einstellungen.ZellenRadiusGeben();
  public boolean istMauer = false;
  public boolean init = false;
  public boolean zelleBekannt = false;
  public boolean hatPowerKruemel = false;
  
  public ZellDarstellungImpl(int x, int y)
  {
    super(x, y);
    ZelleInitialisieren(x, y);
  }
  
  public ZellDarstellungImpl(int x, int y, int zellRadius)
  {
    super(x, y, zellRadius);
    ZelleInitialisieren(x, y);
  }
  
  private void ZelleInitialisieren(int x, int y)
  {
    if (!this.init)
    {
      this.darstellung = new Rectangle2D.Double(this.xTransformiert, this.yTransformiert, Einstellungen.ZellenRadiusGeben() * 2, Einstellungen.ZellenRadiusGeben() * 2);
      this.zentrumX = (this.xTransformiert + Einstellungen.ZellenRadiusGeben());
      this.zentrumY = (this.yTransformiert + Einstellungen.ZellenRadiusGeben());
      this.anzeigeManager.ZellDarstellungHinzufuegen(this);
    }
  }
  
  public void VerbindungenZeichnen(Graphics g) {}
  
  private void VerbindeZuNachbar(Graphics g) {}
  
  public void DatenZeichnen(Graphics g)
  {
    g.setColor(Color.WHITE);
    g.drawString(this.positionX + ":" + this.positionY, this.xTransformiert, this.yTransformiert + 10);
  }
  
  public void PositionAktualisieren()
  {
    super.PositionAktualisieren();
    
    ((Rectangle2D.Double)this.darstellung).setRect(this.xTransformiert, this.yTransformiert, 
      Einstellungen.ZellenRadiusGeben() * 2, Einstellungen.ZellenRadiusGeben() * 2);
    Aktualisieren();
  }
  
  public boolean IstMauerGeben()
  {
    return this.istMauer;
  }
  
  public void IstMauerSetzen(boolean b)
  {
    this.istMauer = b;
  }
  
  public boolean HatPowerKruemel()
  {
    return this.hatPowerKruemel;
  }
  
  public void PowerKruemelSetzen(boolean b)
  {
    this.hatPowerKruemel = b;
  }
  
  public char TypGeben()
  {
    return 'Z';
  }
}
